\NeedsTeXFormat{LaTeX2e}
\listfiles

\documentclass[12pt,a4paper,twoside]{article}
\usepackage{graphics,epsfig}
\usepackage[latin1]{inputenc}
\usepackage{alltt,color,xcolor}
\usepackage{xypic}
\usepackage{amsfonts,amssymb,amsmath}
\usepackage{wrapfig}


\setlength{\textwidth}{161mm} %21cm - (2 * 1in)
\setlength{\textheight}{224mm}
\setlength{\oddsidemargin}{0pt}
\setlength{\evensidemargin}{0pt}
\setlength{\topmargin}{0pt}

\newcommand{\lucky}{{\tt lucky}}
\newcommand{\lurettetop}{{\tt lurettetop}}
\newcommand{\xlurette}{{\tt xlurette}}
\newcommand{\lutin}{{\tt lutin}}
\newcommand{\genfake}{{\tt gen\_fake\_lutin}}
\newcommand{\showluc}{{\tt show\_luc}}
\newcommand{\eps}{\varepsilon}
\newcommand{\ind}{\hspace{2cm}}

\newcommand{\red}{\color{red}}
\newcommand{\blue}{\color{blue}}
\newcommand{\blued}{\color{blue2}}
\newcommand{\bluet}{\color{blue3}}
\newcommand{\green}{\color{green4}}

\newcommand{\op}{$\langle$}
\newcommand{\cl}{$\rangle$}

\newcommand{\semce}[2]{\[#1\] \ #2}
\newcommand{\semtest}[3]{\[${\tt #1}$ #2\]_t \ #3}

\newcommand{\alors}{{$\rightarrow \ $}}
\newcommand{\fleche}{{\rightarrow}}
\newcommand{\term}[1]{{\bluet \tt#1}}
\newcommand{\metaterm}[1]{#1}
\newcommand{\nt}[1]{{\green \tt {<}}{\green \bf#1}{\green \tt {>}}}
\def\int{\nt{int}}
\def\float{\nt{float}}
\def\ident{\nt{ident}}
\newcommand{\identt}[1]{{\green \tt {<}}{\green \bf ident$_{#1}$}{\green \tt {>}}}
\def\preident{\nt{pre}}
\def\nodes{\mathcal{N}}
\def\trans{\mathcal{T}}
\def\graph{\mathcal{G}}

\def\mnodes{$\mathcal{N}$}
\def\mtrans{$\mathcal{T}$}
\def\mgraph{$\mathcal{G}$}

% CROCHET BIZARRE
\def\[{\normalfont{\mbox{[\hspace{-.35ex}[}}}
\def\]{\normalfont{\mbox{]\hspace{-.35ex}]}}}



%\input{commandes.tex}

%\gdef\SetFigFont#1#2#3#4#5{}

\begin{document}  
%\pdfpagewidth= 21cm
%\pdfpageheight= 29.7cm

\begin{center}
{\large \bf IST-2001-34363 -- SafeAir II}\\
\rule{4cm}{1pt}\\[8mm]
{\Large \bf Deliverable D1.1}\\[10mm]
{\Large \bf Test Tool Specification}\\[5mm]
\rule{4cm}{1pt}\\[8mm]

\end{center}

\tableofcontents
 
\section{Introduction}
\tableofcontents

The testing tool which is under adaptation --- in fact, under redesign --- in the
framework of the project, is called Lurette, and is based on the principles
described in \cite{lurette:rtss}. We first recall those principles, before 
presenting the specifications of the new tool.

\subsection{What kind of testing?}
Of course, formal verification should be used whenever possible. However, testing
will always be necessary. In this work we concentrate on cases where formal
verification cannot be applied, i.e.:
\begin{itemize}
\item for complex programs and properties, involving numerical aspects
\item for black-box programs, (a part of) the source of which is not available or
written in a low level language.
\end{itemize}
On the other hand, we consider functional testing: the program will be a black
box, which is only executable, of which we want to check some properties.

\subsection{Testing reactive systems: specific problems}

In addition to usual problems of test case generation --- selection of realistic
test cases, oracle and diagnosis, defining and improving coverage ---, testing 
reactive systems  raises some specific problems:
\begin{itemize}
\item test cases are not just input values, but {\em sequences\/} of input values,
and these sequences can be very long.
\item a reactive system is often intended to control its environment. As a
consequence, realistic test sequences can depend on the behaviour of the system
under test (SUT). More precisely, the selection of an input value, at a given
sequence point, can depend on the reaction (previous outputs) of the SUT to the
previous elements of the sequence. Hence, realistic sequences cannot be generated
off-line, and the SUT must be involved in the generation.
\end{itemize}

\subsection{Testing reactive systems: the proposed solution}
In \cite{lurette:rtss}, we propose to generate test sequences from a
user-given specification of realistic (or ``interesting'') scenarios.
Such specification, say $\Sigma$ is a non deterministic description
of sequences involving both input ($I$, to be generated by the tool)
and output ($O$, computed from $I$ by the SUT) variables of the SUT.
The only restriction is that the constraints on inputs $I$, at a
given point of a sequence, may only depend on the {\em past} values
of outputs $O$. Moreover, the user can also provide another
specification, say $\Omega$, of the same kind as $\Sigma$, which
describes correct behaviours or desired properties of the SUT.

The tool generates input sequences as follows: it first uses $\Sigma$
to randomly select a first input vector $i$ satisfying the
specification; then it provides the vector to the SUT for one
reaction, and gets back the corresponding output vector $o$; $i$ and
$o$ are checked against the oracle $\Omega$; then the internal state
of $\Sigma$ and $\Omega$ are updated according to $i$ and $o$, and a
new step can start.

\subsection{Description of non-deterministic behaviours}

An important point is the way behaviours are specified. Basically,
such a specification should behave as an automaton, providing
constraints on $I$ according to its internal state, and moving from
state to state according to the current values of $I$ and $O$. In the
previous version of Lurette, this specification was just an observer
written in Lustre. In the new version, we want to allow various
formalisms for that, because Lustre observers are neither always
convenient, nor powerful enough: for instance, it is often
interesting to drive the generation using weights or probabilities.
This why the tool is organised around an internal format, called
Lucky, into which the user's formalisms are intended to be
translated.


\section{Architecture of the tool}


 
\tableofcontents


\subsection{The general picture of involved tools, languages and formats}


Figure~\ref{gen-picture} shows the various set of tools, languages
and formats involved in the use of Lurette. We describe in the
following each element of this figure in turn.


\begin{figure}[h]
  {\hfill
  \epsfig{figure=gen-pict.eps,width=10cm} \hfill} \\
  
  Circle boxes stand for file formats, square boxes stand for tools,
  thin arrows stand for ``is compiled into'' 
% and are labelled by the compiler name 
  (the arrow is dashed if the compiler does not exist
  yet), thick arrows stand for ``provide files to the tool''.

  \caption{The general picture of involved tools, languages and formats}
  \label{gen-picture}
\end{figure}


\paragraph{The System under Test (SUT).}
It is the reactive program  to be tested. Currently, Lurette only
works with lustre. More precisely, it works with C code that has been
generated by the lustre compiler. This code follows a particular
format named the \emph{poc} format, which is described in the lustre
documentation. Most synchronous programming languages (e.g., scade, esterel,
signal) generates C code with a similar shape; hence adapting Lurette
to make it work with them should not be difficult (hence the dashed
arrows in Figure~\ref{gen-picture}).



\paragraph{The oracle: test results perusal.}
In the current version of Lurette, the oracle is a lustre observer
returning a boolean. Lurette is again feeded with C (poc) versions of
oracles.


\paragraph{Input sequence generation.}

The original part of the new version of Lurette is really in the way
the SUT input sequences are generated.  Note that it is really the
most difficult part of an automated testing process. The aim is to
provide has much flexibility as possible to the test scenario
designers. Those scenario are written in a dedicated and high level
programming language, \lutin, that is basically lustre expressions
plus regular expressions to express sequences, and the possibility
to assign weights to the different scenarios. We do not describe
\lutin\ here (yet), but a detailed description of lucky, the
intermediary format \lutin\ programs are compiled into, is given in
Appendix~\ref{lucky-ref}.
%
One of the goal when designing lucky was to have a language with a
simple operational semantics (it is an automaton) that is
sufficiently general to model any non-deterministic formal
description.

\paragraph{Tools.} \lurettetop, together with its graphical wrapper
\xlurette, are tools that let users specify the various test
parameters: name of the SUT, of the oracle, of the environment
description, the test length, etc (cf Appendix~\ref{xlurette}
and~\ref{lurettetop}). Then, they are building a single executable
file that is run and which stops whenver a property is violated in
the oracle.
A small tutorial of \xlurette\ is given in Appendix~\ref{tutorial}.
%The usage of the various available tools is described in Appendix~\ref{tools}.


\subsection{Lurette execution process}

We recall now how the different entities (SUT, oracle, environment)
work all together inside Lurette automated testing tools. 



\begin{wrapfigure}{r}{6cm}
%\vspace{-2cm}
  \mbox{ \scalebox{.45}{\input{lurette-start.pstex_t}}}
  \caption{Lurette start-up}
  \label{lurette-start}
\end{wrapfigure}



Figure~\ref{lurette-start} shows up what happens when lurette starts
up. The idea is that environment outputs serve as SUT inputs, and SUT
outputs serve as environment inputs. In order to be able to start such
a looped design, one entity have to start first.  The choice has been
made that the environment will. This means that a sensible
environment for lurette is one that can generate values without any
input at time 1. 

The role of {\tt boot} keyword of Figure~\ref{lurette-start} is
precisely to indicate that the environment is indeed starting first;
once the environment received the {\tt boot} signal, it
(non-deterministically) produce an ouput vector $I$, which will be
used by the SUT. $try / I$ means that once one step is done in the
SUT to compute its output $O$, the previous state of the SUT is
immediatly restored. This to allow several input vectors $I$ to be
tried at each step, to perform a kind of \emph{thick} test. In
Figure~\ref{lurette-start}, the different tries are distinguished
thanks to the index  $i$. Hence, at the $i^{th}$ tries, the
vectors $I_i$ and $O_i$, respectively produced by the environment and
the SUT, are tried in the oracle. 



\begin{figure}[h]
 \begin{minipage}{0.5\textwidth}
  \mbox{ \scalebox{.45}{\input{lurette-step.pstex_t}}}
  \caption{Lurette steps \label{lurette-step}}
\end{minipage}
%
 \begin{minipage}{0.5\textwidth}
  \mbox{ \scalebox{.5}{\input{lurette-try.pstex_t}}}
  \caption{Lurette tries}
  \label{lurette-try}
\end{minipage}

\end{figure}


% \begin{wrapfigure}[7]{l}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-step.pstex_t}}}
%   \caption{Lurette steps \label{lurette-step}}
% \end{wrapfigure}
% %
% \begin{wrapfigure}[0]{r}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-try.pstex_t}}}
%   \caption{Lurette tries}
%   \label{lurette-try}
% \end{wrapfigure}




Once a sufficient number of tries have been done (the thickness of
the test is one of the lurette parameter users have control on), one
index is chosen, say $j$, and the step corresponding to that index is
really\footnote{is the sense that the previous state of machines is
  not restored this time.} done (Figure~\ref{lurette-step}). Note
that since the SUT and the oracle are deterministic machines, we just
need to give them the vector $I_j$ and $O_j$ once more. But this is
not true for the environment, which is undeterministic; that is the
reason why we give it the index $j$; of course, this means that the
environment interpreter needs to remember which
index leads to which internal state. 



% \begin{wrapfigure}[4]{r}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-try.pstex_t}}}
%   \caption{Lurette tries}
%   \label{lurette-try}
% \end{wrapfigure}



Then the process continue as in Figure~\ref{lurette-start}; the only
difference, as shown in Figure~\ref{lurette-try}, is that the
environment is feeded with the SUT output vector $O_j$ which was
elected at the previous step.

%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------


\input{english.macros}


\newpage
\bibliographystyle{alpha}
\bibliography{bib}


\newpage
\tableofcontents

%---------------------------------------------------------------------
%---------------------------------------------------------------------

\newpage
\appendix


\section*{Appendices}

\section{Lucky, the internal format of test scenario specification}
\paragraph{Foreword}
\label{lucky-ref}
Lucky is intended to be an intermediary format targeted by third
party tools (e.g., Lustre~\cite{lustre}, Lutin~\cite{roux02},
Nbac~\cite{jeannet99}); hence the emphasis has been put on parsing
easiness rather than on syntactical elegance. Indeed, Lucky's grammar
is LL(1). 


This document is therefore mainly intended for persons who would like
to automatically generate lucky code. But of course it can also be
used by discriminated hackers that want to manually specify the
behaviour of indeterministic processes.  Along those lines, a minimal
background in compilation is assumed to read this appendix.

Moreover, if you are reading this document on a black and white
paper, probably you didn't noticed that we have also used colours to
distinguish between terminals, non-terminals and grammar
meta-symbols.  Therefore if, like me, you can not parse black and
white grammar rules, you might be interested in printing that
document onto a colour printer, or reading grammar on the screen.

\subsection*{Overview}

Synchronous programs~\cite{esterel,lustre,signal} deterministically
produce outputs from input values.  To be able to compile,
synchronous programs need to be fully deterministic.
%
However, sometimes, we want to be able to describe synchronous
systems in a non deterministic manner:

\begin{itemize}
\item if one want to describe (and simulate) an intrinsically
  indeterministic system.  A typical example is when one want to
  describe the environment of a reactive program; it can be very
  useful for testing and simulation purposes.
  
\item Another potential use of the animation non deterministic code
  is when one wants to simulate partially written reactive programs
  (some nodes are lacking). The idea is then to take advantage of
  program signatures, pre/post conditions, or code chunks to simulate
  those programs the more realisticly as possible, taking into
  account the available constraints, and drawing the indeterministic
  parts. This can be very useful to simulate and test applications at
  every stage of the development process.
\end{itemize}

We call an \emph{indeterministic program} such pieces of code that
produce their outputs in-deterministically.  Lucky is a language to
describe such indeterministic programs.  Basically, it is an
automaton which transitions are labelled by expressions. As in
Lustre, expressions represent set of equations over boolean and
numeric values\footnote{A restriction is that numeric constraint
  ought to be linear (e.g., $x+y > 3$, but not $x^2+y^2>2$ nor $log~s
  + sin~r > e^s$). }  that define an atomic reaction (in the
synchronous sense).  The key difference with lustre is that those
equations may admit several solutions, hence the first source of
non-determinism.  The second source of non-determinism is due to the
fact that several expressions can be reachable from the current
state; the choice is done according to weights that also label
transitions.  Those weights let one assign probabilities to the
different temporal scenarios defined by the automata. More details
about the semantics of such automata is given in
Appendix~\ref{semantics}.

Lucky can be seen as a language to program stochastic processes (more
precisely, Markov chains). Lucky code can then be simulated with the
\lucky\ interpreter (cf Appendix~\ref{lucky}).



To sum up, the Lucky language is a syntax for describing
indeterministic automata labelled by formula. Each step in the
automaton consists in choosing a transition, namely to choose a
formula.  Each formula represents a set of equations that define
atomic reactions of the system.  This set of equations is solved and
a solution is drawn which provide the program outputs of the current
step.



%---------------------------------------------------------------------
%---------------------------------------------------------------------
\subsection{Lucky syntax rules}

The syntax rules are given in an extended-BNF-like notation, where
the meta-symbols `\metaterm{\alors}', `\metaterm{\op}',
`\metaterm{\cl}',`\metaterm{?}',`\metaterm{*}', and `\metaterm{+}'
have the usual meaning. Non-terminals are in bold between brackets
(\nt{like this}) and terminals are in typewriter font (\term{like
  that}).



In this section, we give the syntax rules as well as the informal
semantics of each syntactical constructs. A more formal semantics is
given in Appendix~\ref{semantics}.
  
%---------------------------------------------------------------------
\subsubsection{Lexical convention}

The lexical conventions for blanks, identifiers (\ident), integer
(\int) and floating point (\float) literals are the usual ones.  More
precisely, they are the ones of Ocaml (Chapter 6 of the Ocaml user's
manual~\cite{ocaml-ref}), and are recalled in the following.

\label{lex-conv}

\paragraph{Blanks}
  
The following characters are considered as blanks: space, newline,
horizontal tabulation, carriage return, line feed and form feed.
Blanks are ignored, but they separate adjacent identifiers, and
literals.

\paragraph{Comments}

  
Comments are introduced by the two characters (*, with no intervening
blanks, and terminated by the characters *), with no intervening
blanks. Comments are treated as blank characters. Comments do not
occur inside string or character literals. Nested comments are
handled correctly.

\paragraph{Identifiers}



\begin{alltt}
     \nt{ident} \alors \op\nt{letter} | \term{\_}\cl \op \nt{letter} | \term{0}...\term{9} | \term{\_} | \term{'} \cl   
     \nt{letter} \alors \term{A }...\term{ Z} | \term{a }...\term{ z}
\end{alltt}
  
Identifiers are sequences of letters, digits, \_ (the underscore
character), and ' (the single quote), starting with a letter or an
underscore. Letters contain at least the 52 lowercase and uppercase
letters from the ASCII set. The current implementation (except on
MacOS) also recognises as letters all accented characters from the
ISO 8859-1 (``ISO Latin 1'') set. All characters in an identifier are
meaningful. The current implementation places no limits on the number
of characters of an identifier.

\paragraph{Integer literals}

  
\begin{alltt}
   \nt{int} \alors 
            \op\term{-}\cl? \op \term{0}...\term{9} \cl+ 
          | \op\term{-}\cl? \op\term{0x}|\term{0X}\cl \op \term{0}...\term{9} | \term{A}...\term{F} | \term{a}...\term{f} \cl+
          | \op\term{-}\cl? \op\term{0o}|\term{0O}\cl \op \term{0}...\term{7} \cl+
          | \op\term{-}\cl? \op\term{0b}|\term{0B}\cl \op \term{0}...\term{1} \cl+
\end{alltt}
     
  
  An integer literal is a sequence of one or more digits, optionally preceded
by a minus sign. By default, integer literals are in decimal (radix 10). The
following prefixes select a different radix: 
                                         
%\newpage
\begin{alltt}
        -----------------------------------
        | Prefix |    Radix               |
        -----------------------------------
        | 0x, 0X | hexadecimal (radix 16) |
        | 0o, 0O | octal (radix 8)        |
        | 0b, 0B | binary (radix 2)       |
        -----------------------------------
\end{alltt}


(The initial 0 is the digit zero; the O for octal is the letter O.)
The interpretation of integer literals that fall outside the range of
representable integer values is undefined.

% Integer numbers
% ---------------
  
Integer values are integer numbers from $-2^{30}$ to $2^{30-1}$, that is
$-1073741824$ to $1073741823$. The implementation may support a wider
range of integer values: on 64-bit platforms, the current
implementation supports integers ranging from $-2^{62}$ to $2^{62-1}$.


\paragraph{Floating-point literals}

  
\begin{alltt}
   \nt{float} \alors \op-\cl? \op \term{0}...\term{9} \cl+ \op\term{.} \term{0}...\term{9} \cl? \op\op\term{e}|\term{E}\cl \op\term{+}|\term{-}\cl? \op \term{0}...\term{9} \cl+\cl
\end{alltt}
                                        
  
Floating-point decimals consist in an integer part, a decimal part
and an exponent part. The integer part is a sequence of one or more
digits, optionally preceded by a minus sign. The decimal part is a
decimal point followed by zero, one or more digits. The exponent part
is the character e or E followed by an optional + or - sign, followed
by one or more digits. The decimal part or the exponent part can be
omitted, but not both to avoid ambiguity with integer literals. The
interpretation of floating-point literals that fall outside the range
of representable floating-point values is undefined.


% Floating-point numbers
% ----------------------
  
Floating-point values are numbers in floating-point representation.
The current implementation uses double-precision floating-point
numbers conforming to the IEEE 754 standard, with 53 bits of mantissa
and an exponent ranging from -1022 to 1023.


%---------------------------------------------------------------------
\subsubsection{Data}

As in lustre, expressions representing a set of equations define
atomic reactions (in the synchronous sense) of the lucky
indeterministic machines.  The subsections from~\ref{type}
to~\ref{expressions} describe the syntax of those expressions.


\paragraph{Variable  declarations}

\begin{alltt}
  \nt{var\_decl} \alors \term{(} \identt{var}\term{,} \nt{type} \term{)} 
  \nt{genvar\_decl} \alors 
\ind   \term{(} \identt{var}\term{,} \term{bool} \term{)} 
\ind | \term{(} \identt{var}\term{,} \term{int}   \op, \int,   \int \cl? \term{)} 
\ind | \term{(} \identt{var}\term{,} \term{float} \op, \float, \float\cl? \term{)} 

  \nt{type} \alors \term{bool} | \term{int} | \term{float} 
\end{alltt}


We made a distinction between \nt{var\_decl} and \nt{genvars\_decl}
because, for output variables, we wanted to let one specify bounds
globally, to avoid the repetition of boring (and potentially
expensive) ``{\tt V < max \&\& V~>~min~}'' statements all along the
formulae.  Of course, such bounds would not make sense for input
variables, hence the distinction between \nt{var\_decl} and
\nt{genvars\_decl}. \\

nb: here and in the following, identifiers are indexed by labels
(e.g., {\green $var$} in \identt{var}) that are just here to help to
understand a bit of the semantics behind the syntax. Syntactically,
they are all identifiers.

% XXX Similar way of initialising arrays and struct should be provided
% too.

\paragraph{Memory declarations (pre)}
%\paragraph{Pre declarations}
\label{pre}
\label{memory}

\begin{alltt}
  \nt{prevar\_decl} \alors \term{(} \preident\term{,} \nt{type} \term{)} 
  \preident \alors \term{pre} \term{(} \int \term{,}  \identt{var} \term{)} 
\end{alltt}



Those rules says how to declare pre variables. Indeed, as in Lustre,
it is possible to prefix variables with pre statements (cf
Appendix~\ref{formula}). Unlike in lustre, you need to declare the
pre variables you use however. Another difference is that you do not
write \term{pre pre pre X} but \term{pre(3,X)}.


%---------------------------------------------------------------------
\paragraph{Expressions}

%\subsubsection{Formula and numeric expressions}
\label{expressions}
\label{formula}

\begin{alltt}
  \nt{formula\_def} \alors \term{(} \identt{var}\term{,} \nt{formula} \term{)}
\end{alltt}


%  \nt{formula\_eps} \alors \nt{formula} | \term{eps}
\begin{alltt}
  \nt{formula} \alors
\ind   \identt{var} 
\ind | \term{pre(}\int\term{,} \identt{var}\term{)}
\ind | \term{true} 
\ind | \term{false} 
\ind | \term{(} \nt{formula} \term{)} 
\ind | \term{||} \nt{formula} \nt{formula} 
\ind | \term{&&} \nt{formula} \nt{formula}
\ind | \term{#} \nt{formula} \nt{formula}
\ind | \term{!} \nt{formula}
\ind | \term{IfThenElse} \nt{formula} \nt{formula} \nt{formula} 
\ind | \term{==} \nt{formula} \nt{formula} 
\ind | \nt{op} \nt{numeric} \nt{numeric} 
  \nt{op} \alors \term{=} | \term{<>} | \term{<} | \term{<=} | \term{>} | \term{>=} 
 
  \nt{numeric} \alors
\ind   \identt{var} 
\ind | \term{pre(}\int\term{,} \identt{var}\term{)} 
\ind | \int 
\ind | \float 
\ind | \term{(} \nt{numeric} \term{)} 
\ind | \nt{numeric} \nt{op\_numeric} \nt{numeric}
\ind | \term{IfThenElseNum} \nt{formula} \nt{numeric} \nt{numeric} 
  \nt{op\_numeric} \alors \term{+} | \term{-} | \term{*} | \term{/} | \term{mod} 
\end{alltt}

Those rules define formulae with numerical constraints.
Terminal \term{||} stands for the disjunction, \term{\#} for the
exclusive disjunction (xor), \term{\&\&} for the conjunction, and
\term{!} for the negation.

There are two kinds of expressions: booleans expressions (or formula)
and numeric expressions over integers and floats. Note that automata
transitions are only labelled by formula, false formulae representing
unsatisfiable sets of equations.

Notice that we can go from boolean to numeric thanks to the
\term{op} construct, and from numeric to boolean thanks to the
\term{IfThenElseNum} construct.

%---------------------------------------------------------------------
\subsubsection{Control}
\label{control}

The control part decide which set of equations will be used to
obtain the output values for the current step. In other words, it
defines the temporal behaviour of lucky machines. The elected formula
is drawn among the formula reachable from the current node. This
draw is done according to the probabilities defined by weights
(Appendix~\ref{weights}) labelling the automata transitions
(Appendix~\ref{transitions}). Such weights can be variables
(Appendix~\ref{control-expr}).


\paragraph{Weights}
\label{weights}

\begin{alltt}
  \nt{weight} \alors \int | \identt{w} | ! \identt{w}
\end{alltt}

Weights can either be integers or variable identifiers that ought to
be bound to some integer value (by means of control expression
statements of subsection~\ref{control-expr}).  The bang is a kind of
complementary operator: \term{!x} returns 1 if x is bound to an
integer strictly larger than 0; it returns 0 otherwise.


\paragraph{Control expressions}
\label{control-expr}

%  \nt{ctrl\_expr\_defs} \alors \nt{ctrl\_expr\_def} \op \term{;}  \nt{ctrl\_expr\_def}  \cl* | \(\varepsilon\) 
\begin{alltt}
  \nt{ctrl\_expr\_def} \alors \term{(} \identt{ctrl}\term{,} \op \nt{ctrl\_statement} ; \cl+ \term{)}
  \nt{crtl\_statement} \alors
\ind   \term{Set} \identt{w} \int
\ind | \term{Set_between} \identt{w} \int \int \int 
\ind | \term{Draw_between} \identt{w} \int \int 
\ind | \term{Draw_gauss} \identt{w} \float \float 
\ind | \term{Dec} \identt{w}
\ind | \term{IfThenElse} \nt{test} \term{(} \identt{ctrl} \term{)} \term{(} \identt{ctrl} \term{)}

  \nt{test} \alors \nt{op} \op \identt{w} | \int \cl \op \identt{w} | \int \cl
  \nt{op} \alors \term{<=} | \term{<} | \term{>=} | \term{>} | \term{=}
\end{alltt}
%\ind     | \term{Return} \nt{number}
%    \nt{number} \alors \ident | \int 

A control expressions (which label transitions, cf
Appendix~\ref{transitions}) is evaluated if and only if it belongs to
a transition that is in the path used to obtain the elected formula,
namely, the path that has been chosen to perform the step.

Control expressions are made of a sequence of statements that
basically lets one:
\begin{itemize}
\item initialise a counter (i.e., a positive integer) by assigning to
  it a finite value (e.g., \term{Set my\_counter 3}), a
  value uniformally drawn in an interval (e.g., \term{Draw\_between
    my\_counter 2 23}), a value drawn according to a normal law
  (e.g., \term{Draw\_gauss my\_counter 10. 1.5})
\item decrement that counter (e.g., \term{Dec my\_counter})
\end{itemize}



%---------------------------------------------------------------------
\paragraph{Transitions}
\label{transitions}

%  \nt{arcs} \alors \nt{arc} \op \term{;} \nt{arcs} \cl*
\begin{alltt}
  \nt{arc} \alors \term{From} \int \term{To} \int \term{With} 
\ind \ind \nt{weight} \term{:} \nt{formula} \op : \identt{ctrl} \cl?
\end{alltt}

Weight arc labels (at the lhs of formula) are positive integers or
\nt{ident}s that ought to have been set in previous reactions during
a control expression evaluation. 


%---------------------------------------------------------------------
\subsubsection{Pragmas}

\begin{alltt}
\nt{pragma\_list} \alors \term{\%} \nt{pragma} \op \term{;} \nt{pragma} \cl* \term{\%} 
\nt{pragma} \alors \term{"}\ident\term{"}\term{:}\term{"}\ident\term{"}
\end{alltt}

They can occur after any ident or operator. A pragma is a pair of
string list that begins and ends with the terminal \term{\%}.
% They are intended to be used for source recovering.

%---------------------------------------------------------------------
\subsubsection{Lucky files}


%\ind \term{types}      \term{=} \nt{type\_decl}   | \op \term{;} \nt{type\_decl} \cl* \term{,} 
\begin{alltt}
  \nt{lucky\_file} \alors
\ind \term{inputs}     \term{=} \nt{var\_decl}    | \op \term{;} \nt{var\_decl} \cl* \term{,} 
\ind \term{outputs}    \term{=} \nt{genvar\_decl} | \op \term{;} \nt{genvar\_decl} \cl* \term{,} 
\ind \term{locals}     \term{=} \nt{genvar\_decl} | \op \term{;} \nt{genvar\_decl} \cl* \term{,} 
\ind \term{pre}        \term{=} \nt{prevar\_decl} | \op \term{;} \nt{prevar\_decl} \cl* \term{,} 
\ind \term{ctrl\_expr}  \term{=} \nt{ctrl\_expr\_def}| \op \term{;} \nt{ctrl\_expr\_def} \cl* \term{,} 
\ind \term{formula}    \term{=} \nt{formula\_def} | \op \term{;} \nt{formula\_def} \cl* \term{,} 
\ind \term{start_node} \term{=} \int\term{,} 
\ind \term{arcs\_nb}    \term{=} \int\term{,} 
\ind \term{nodes\_nb}   \term{=} \int\term{,} 
\ind \term{transient\_nodes} \term{=} \int \op \term{;} \int \cl*\term{,} 
\ind \term{arcs}       \term{=} \nt{arc} | \op \term{;} \nt{arc} \cl+ \term{.} 
\end{alltt}

We basically first declare the names and types of input, output,
local, and pre variables that are used in formulae. Then we declare a
list of \nt{ctrl\_expr} labels (Section \ref{control-expr}); such
expressions can be used, for instance, to let one specify control
over how many times each loop is executed.  Then, follows the
automata starting node, arc and node numbers, and its transitions.

The mapping between control expressions and their labels
(\identt{ctrl}) that appear in the rhs of formula ought to be defined
in the `\term{ctrl\_expr =}' rule.


Transient nodes define which steps in the automaton is necessary to
define a step of lucky reactive program. The idea is that, if the
current node is transient, then another step in the automaton is done
until a non transient (stationary) node is reached. Then, the
formula that will be used to compute the output values of the current
instant is the conjunction of all the formula labelling the traversed
transitions. A more formal definition is given in
Appendix~\ref{semantics}.


%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
\subsection{Lucky semantics}
\label{semantics}

In the previous section, we have given the syntax of Lucky constructs
together with their informal semantics. In this section, we propose
more formal semantic definitions of the syntactical constructs that
deserve one.


\paragraph{Definitions.}
A \emph{Lucky Automaton} is a finite automaton which nodes are
distinct integers, and which transitions are labelled by a sequence
of positive integers $w = (w_n)_{n \leq 0}$ (weights), a sequence of
formulae $f = (f_n)_{n \leq 0}$, and a control expression\footnote{A
  control expression is a term made of the syntax rules of
  Appendix~\ref{control-expr}}. We suppose that 2 transitions with the
same origin and target nodes have  different labels; this
is not a restriction as one just need to add the weight labels is
that case.

The intuition behind the sequence of formulae $f$ is that, since
formulae depend on input values and memory (pre),  $\forall i
\leq 0$, $f_i$ is the formula where inputs and pre have been
substituted by their values at (synchronous) time $i$. 

 
Let $\mathcal{N}$ be the set of nodes of the current (implicit)
automaton, and $\mathcal{T}$ be the set of transitions. For any a
positive integer $n$, a transition $\tau_n$ from node $i$ to node $j$
labelled by ($w_n$, $f_n$, ce) is a 5-tuple indifferently written
$(i,w_n,f_n,ce,j)$ or \xymatrix{ *++[o]{i} \ar[r]^{w_n:f_n:ce} &
  {j}} in the following.


%---------------------------------------------------------------------
\subsubsection{Control}
\label{sem-control}


\paragraph{Automaton (Micro-)steps}
\label{sem-micro}


A step in the automaton is done by drawing a transition according to
weights.
%
More precisely, let $\tau = (\tau_n)_{n \leq 0}$ be the sequence of
transitions that are made in the automaton; $\tau$ is (a Markov
chain) defined as follows. 

$\forall n > 0$, $\forall s \in \nodes$, if $\{(s, w_n^i, f_n^i,
ce^i, s^i)\}_{i \in \{1, ..., m\}}$ is the set of all the transitions
with $s$ as source node, then:

$$ 
\forall j \in \{1, ..., m\}, %[1, m], 
 \ \mathbb{P}[\tau_n = s^j \ | \ \tau_{n-1} = s] =
 \frac{w_n^j}{\overset{m}{\underset{i=1}{\sum}} w_n^i } 
$$

$\tau$ is an \emph{homogeneous} Markov chain if all weights are
constant sequences. 

\paragraph{Lucky reactive machine steps}
\label{sem-macro}

At the control level, a step in the lucky reactive machine consist in
choosing a formula. Such a formula is obtained by performing
micro-steps in the automaton (from the current step) until a
stationary node is reached; the resulting formula is the conjunction
of formula labelling traversed transitions.

\paragraph{Dynamic weights and control expression evaluation}
\label{dynamic}


For transitions labelled by integers, the sequence $w$ is a constant
one. Otherwise, the sequence $w$ is also a Markov chain whose values
is obtained evaluating control expressions. In
Appendix~\ref{sem-micro}, we did not define how to compute weights.
We provide now a refined definition of the sequence $\tau$ that
precise the value of the sequence $w$.

To do that, we introduce another data structure, $\sigma =
(\sigma_n)_{n \leq 0}$, that denotes the sequence of stores
($\mathcal{S}$) containing a finite set of pairs interpreted as
mappings from (control expression) identifiers to integers.
Initially, $\sigma_0$ is the empty set. Then, the sequences $\tau$, $w$, and
$\sigma$ are defined as follows.

$$ 
\forall j \in \{1, ..., m\}, %[1, m], 
 \ \mathbb{P}[\tau_n = s^j, \sigma_n =
                \semce{ce^j}{\sigma_{n-1}} \ | \ \tau_{n-1} = s] =
                \frac{w_n^j |_{\sigma_{n-1}}}{\overset{m}{\underset{i=1}{\sum}} w_n^i |_{\sigma_{n-1}}} 
$$

\noindent
where $x|_\sigma$ denotes the term $x$ applied to the substitution set
$\sigma$, and $\lambda e \sigma .(\semce{e}{\sigma}) :$
\nt{ctrl\_expr} \alors $\mathcal{S}$ \alors
$\mathcal{S}$ is defined inductively as follows: \\


$
\begin{array}{rcl}

\semce{{\tt ce1 ; ce2}}{\sigma} &\equiv& \semce{{\tt  ce2}}{(\semce{{\tt ce1}}{\sigma})}   \\

\semce{{\tt Set \ id \ i}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, i})\} \\

% \semce{{\tt Set\_between \ id \ min \ max}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, i})\}\\ 

\semce{{\tt Draw\_between \ id \ min \ max}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, \mathcal{U}(min,max)})\}\\ 

\semce{{\tt Draw\_gauss \ id \ m \ v}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, \mathcal{G}(m, v)})\}\\ 

\semce{{\tt Dec \ id}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, id|_\sigma-1})\} \\

\semce{{\tt IfThenElse \ test \ ( ce1 ) ( ce2 )}}{\sigma} &\equiv& \left \lbrace 
        \begin{array}{l}
                \semce{ce1}{\sigma} $ ~~if $ \semtest{test}{\sigma} \\ 
                \semce{ce2}{\sigma} $ ~~otherwise$
        \end{array}
        \right. \\

\semtest{<=}{{\tt  \ v1 \ v2}}{\sigma} &\equiv& {\tt v1|_\sigma \leq v2|_\sigma} \\

\semtest{=}{{\tt  \ v1 \ v2}}{\sigma} &\equiv& {\tt v1|_\sigma = v2|_\sigma} \\

\semtest{>=}{{\tt \ v1 \ v2}}{\sigma} &\equiv& {\tt v1|_\sigma \geq v2|_\sigma} \\
 
\semtest{<}{{\tt  \ v1 \ v2}}{\sigma} &\equiv& {\tt v1|_\sigma < v2|_\sigma} \\

\semtest{>}{{\tt  \ v1 \ v2}}{\sigma} &\equiv& {\tt v1|_\sigma > v2|_\sigma} \\

\end{array}
$


~\\

\noindent
$\sqcup$ is the set union where existing mapping of {\tt id} in
the set is override; $\mathcal{U}({\tt min, max})$ is the result of a
uniform draw between $min$ and $max$; $\mathcal{G}({\tt m, v})$ is
the result of a normal draw of mean {\tt m} and variance {\tt v}.

Negative weights are considered as null.
%
An implicit rule (that we do not make explicit for the sake of
clarity) is that if $f_n^i$ is not satisfiable, then $w_n^i=0$.

You may have noticed that {\tt Set\_between} is not defined here. Its
semantics is given in Appendix~\ref{recovering} where we further refine
this definition.

\paragraph{Recovering}
\label{recovering}

The concept of \emph{recovering} is introduced to handle the following
remark: suppose that a counter $w$ has been set to 0 after a uniform
draw between 0 and 3. What should happen if no formula is satisfiable
except one guarded by $w$? By default, since $w$ is bound to 0,
the execution should stop. But here, since, e.g. 1, would have been a
valid draw of the value of $w$, we want to be able to ``backtrack''
to the last choice point and allow other values of $w$ to be tried.

In order to implement that feature, we do not only map control
expression identifiers to 1 integer but to 3 of them: the value as
well as its minimal and maximal acceptable values. Hence, whenever no
satisfiable formula can be reached from the current node, we try
again with weight values considered as being acceptable in the hope
that satisfiable formula can be reached then.
The semantics rules of control expressions therefore become: \\


$
\begin{array}{rcl}

\semce{{\tt Set \ id \ i}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, i, i, i})\} \\

\semce{{\tt Set\_between \ id \ min \ max}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, min, i, max})\}\\ 

\semce{{\tt Draw\_between \ id \ min \ max}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, min, \mathcal{U}(min,max), max})\}\\ 

\semce{{\tt Draw\_gauss \ id \ m \ v}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, -\infty, \mathcal{G}(m, v), +\infty})\}\\ 

\semce{{\tt Dec \ id}}{\sigma} &\equiv& \sigma \sqcup \{({\tt id, id|_{\sigma_{min}}-1, id|_{\sigma_{val}}-1, id|_{\sigma_{max}}-1})\} \\

\end{array}
$

~\\


\noindent 
where $\sigma_{min}$, $\sigma_{val}$, and $\sigma_{max}$
respectively maps the identifier to the second, third, and fourth
element of the 4-tuples of $\sigma$.
%
The other control expression syntactical constructs have the same
semantics as in Appendix~\ref{dynamic}.  Note that now, we have
defined {\tt Set\_between}.



\paragraph{Digression.}

The motivation for introduction this notion of dynamic weights is to
be able to encode loop of arbitrary length efficiently.
%
Indeed, in order to encode loops, a naive approach would be to
duplicate transitions the number of times each formula needs to be
looped over.  But this is not very realistic.  First of all, it
consumes a lot of unnecessary space. But the main problem is rather
related to execution time; indeed, since we want to be able to draw
the number of times a loop is executed at runtime, it means that we
need to reconstruct the automaton every time such a loop need to be
done.






%---------------------------------------------------------------------
\subsubsection{Data}
\label{sem-data}

The formula used to compute the output values for the current step is
the conjunction of all the formula labelling transitions traversed
during the automaton (micro-)steps.
% 
%More precisely, the sequence of formulae that is $f = (f_n)_{n \leq 0}$
%
Once a formula has been drawn, it is solved and an element is
fairly\footnote{cf Appendix~\ref{fairness} for a discussion about the
fairness of this draw.} drawn among its set of solutions.

Only linear constraints are supported, but the dimension of the system
of numeric constraints can be bigger than one. In such a case, a
polyhedra library is used to solve the constraints.
%
Another restriction of the current tool that was introduced for
efficiency reasons is that systems of constraints ought to define
convex polyhedra.
 
Along the same lines, be aware that the operations are
exponential in the  polyhedra dimension.

%---------------------------------------------------------------------
\subsubsection{Automata product}
\label{product}


In order to run concurrently Lucky automata that share output values,
we define an automata product. The intent is to have a mean to
perform a kind of language intersection.
%
The advantage is twofold.


\begin{itemize}
\item From a software engineering point of vue, it lets one specify
  separately different non deterministic systems that constraint common
  variables. It therefore allows much more modular and reusable code
  to be written.
  
\item From the code size point of vue, since automata product is
  exponential, writing the product by hand in the first place may not
  be tractable.
  
  One may object that the exponential cost of the product may be
  problematic even if it is done automatically. But note that we only
  need to consider the sub-automata made of the nodes that are
  reachable from the current nodes.


\end{itemize}

%, from a efficiency point of vue,



We need to carefully define our product in such a way that the
probability of each formula to be chosen is not changed. In other
words,  the probability should be same either if we draw in the
product or if we draw concurrently in each individual automaton.
%
% For that reason, we provide in Appendix~\ref{product-proof} a correctness
% proof.

% \subsubsection{Definition}

Let $n_1$ and $n_2$ be 2 nodes of 2 automata that we wish to
multiply. 
%
The following definition holds for the sub-automata made of the
reachable nodes of $n_1$ and $n_2$\footnote{A definition for the
  product of the whole automata can obtained by taking the union of
  the product of all pairs of stationary nodes of both automata, but
  we do not need such a definition since, in our implementation, this
  local product is done on the fly.}.
%
Let $\{ (n_1, w_1^i, f_1^i, ce_1^i, n_1^i) | {i \in \{1, ..., m_1\}}
\} $ and $\{ (n_2, w_2^j, f_2^j, ce_2^j, n_2^j) | {j \in \{1, ...,
  m_2\}}\}$ be the sets of transitions with $n_1$ resp.  $n_2$ as
origin nodes.
%
The product of nodes, $\lambda n_1 n_2. n_1 \otimes n_2$, of type
$\nodes \fleche \nodes \fleche \trans$, is defined by the following
(fix-point) equations:

%  depending on whether nodes have output transitions.

% nodes are transient or stationary.

\begin{itemize}
\item 
%$n_1$ and $n_2$ are stationary nodes: 
if $m_1>0$ and $m_2 > 0$, then
%
\begin{equation}
n_1 \otimes n_2 =
\bigcup _{ \substack{ 1 \leq i \leq m_1  \\ 
                      1 \leq j \leq m_2   } } 
     \{
     (n_1.n_2, 
      w_1^i \times w_2^j, 
      f_1^i \wedge f_2^j, 
      ce_1^i ; ce_2^j, 
      n_1^i . n_2^j) 
      \} \cup n_1^i \otimes n_2^j 
\end{equation}

\item 
% $n_1$ is stationary, $n_2$ is transient: 
if $m_1>0$ and $m_2 = 0$, then
%
\begin{equation}
n_1 \otimes n_2 =
\bigcup _{ \substack{ 1 \leq i \leq m_1   } } 
     \{
     (n_1.n_2, 
      w_1^i , 
      f_1^i , 
      ce_1^i, 
      n_1^i . n_2^j) 
      \} \cup n_1^i \otimes n_2
\end{equation}

The case $m_1=0$ and $m_2 > 0$ is symmetric.

\item 
% $n_1$ and $n_2$ are transient nodes: 
if $m_1=0$ and $m_2 = 0$, then
%
\begin{equation}
n_1 \otimes n_2 = \emptyset
\end{equation}

\end{itemize}
  
\noindent
where the concatenation operator ``.''  stands for set union over
node labels (nodes are no more labelled by integers but by set of
integers).



% XXX reachable undefined ?

For example, the product of node $\{1\}$ and $\{a\}$ for the 2
(sub-)automata of Figure~\ref{todo} result in the automata of
Figure~\ref{done}. Formula and control expression are omitted in
those Figures; the point that we wanted to illustrate with those
figures is that the probabilities are conserved. Indeed, we can check
that, e.g., the probability to chose paths from node 1 to 3
($\frac{1}{1+2} \times \frac{1}{1}$) and from a to d ($\frac{3}{3+5}
\times \frac{11}{7+11}$) is the same as the one from node 1a to node
3d ($\frac{3}{3+5+6+10} \times \frac{11}{7+11}$).



\begin{figure}[h]
\begin{center}  
\epsfig{figure=product-todo.eps,width=6 cm}
\caption{Two (sub-)automata \label{todo}}  
\end{center} 
\end{figure}

\begin{figure}[h]   
\begin{center}  
\epsfig{figure=product-done.eps,width=4.5 cm}
\caption{The product $\{1\} \otimes \{a\}$ 
for the automata of Figure~\ref{todo} \label{done}}
\end{center} 
\end{figure}



%---------------------------------------------------------------------
%---------------------------------------------------------------------
\subsection{A complete example}
\label{example}

Figure~\ref{luc-example} contains a lucky file example. It models the
environment of a plane gyroscope controller written in
lustre~\cite{gyro}. This lustre program is a fault tolerant system
that take as input 8 values (for the slope of one of the 3 dimension)
that comes from 4 sensors, each sensors having 2 wires; it returns a
value for the slope, detecting when sensors/wires produce
inconsistent values.

\begin{figure}
% types        = 
\begin{alltt}
inputs       = (x,float),
outputs      = 
    (xa1,float); (xb1,float); (xa2,float); (xb2,float); 
    (xa3,float); (xb3,float); (xa4,float); (xb4,float),
locals       =
    (e1,float); (e2,float); (e3,float); (e4,float)  ,
pre          =  ,
ctrl_expr    =
  (L1_START, Set W1 10);
  (L1_END, Dec W1);
formula      = 
    (init, && && && && && && && (xa1 = 0) (xa2 = 0) (xa3 = 0) (xa4 = 0) 
                                (xb1 = 0) (xb2 = 0) (xb3 = 0) (xb4 = 0);
    (err1, && && && (< -0.1 ea1) (< ea1 0.1) (< -0.1 eb1) (< eb1 0.1));
    (err2, && && && (< -0.1 ea2) (< ea2 0.1) (< -0.1 eb2) (< eb2 0.1));
    (err3, && && && (< -0.1 ea3) (< ea3 0.1) (< -0.1 eb3) (< eb3 0.1));
    (err4, && && && (< -0.1 ea4) (< ea4 0.1) (< -0.1 eb4) (< eb4 0.1));
    (err,  && && && err1 err2 err3);
    (c1, && (xa1 = x+ea1) (xb1 = x+eb1) );
    (c2, && (xa2 = x+ea2) (xb2 = x+eb2) );
    (c3, && (xa3 = x+ea3) (xb3 = x+eb3) );
    (c4, && (xa4 = x+ea4) (xb4 = x+eb4) ),
start_node   = 0,
arcs_nb      = 4,
nodes_nb     = 4,
transient_nodes = 1; 2; 3,
arcs         =
  From 0 To 1 With 1    : true : L1_START ;
  From 1 To 2 With W1   : true ;
  From 2 To 1 With 1    : && && && && err c1 c2 c3 c4: L1_END ;
  From 1 To 3 With ! W1 : true .
\end{alltt}
\caption{A lucky (.luc) file example: a gyroscope environment \label{luc-example}\label{gyro-luc}} 
\end{figure}

This lucky machine take as input the real value (given by god) of the
slope, and produce 8 disturbed values. The distortions ({\tt ea1,
  ea2, eb1, ...}) are small (local) floats that are drawn between
$-O.1$ and $0.1$.  This is done during 10 steps.

%---------------------------------------------------------------------
%---------------------------------------------------------------------


\subsubsection{About the fairness of the draw inside formulae}
\label{fairness}

Actually, for efficiency reasons, the draw is not really fair.
Indeed, to be fair, we would need to compute the volume of polyhedra
in order to know how many solutions each branch of each choice point
would lead to. And computing such a volume is very expensive; the
best approximated algorithm that we know of is
O($n^7log^2n$)~\cite{lovasz93}.



% (*---------------------------------------------------------------------*)
% (*---------------------------------------------------------------------*)
% (*---------------------------------------------------------------------*)
\newpage
\section{A small \xlurette\ tutorial}
\label{tutorial}

This appendix  contains a small tutorial of the use of \xlurette.
%
Note that tool-tips ought to be displayed if you maintain your mouse
pointer a few seconds on each button and windows of \xlurette.
Therefore, we will not enter into detailed explanations of what each
button does but let you read the tool-tips instead.


Once you have run \xlurette, you ought to obtain the
following window.

\begin{center}  
\epsfig{figure=xlurette-empty.eps,width=6 cm}
\end{center}

Now, suppose you want to test a lustre program file named {\tt
  onlyroll.lus}, which main node is {\tt onlyroll}.  Fill the
``system under test'' text entry, either by hand or by using the
browsing button 
\epsfig{figure=browse.eps,width=0.5cm}
 at the right hand side.


\begin{center}
\epsfig{figure=xlurette-onlyroll.eps,width=6 cm}
\end{center}

Now,  click onto the run button 
\epsfig{figure=run.eps,width=1 cm}

\begin{center}
  
\epsfig{figure=xlurette-onlyroll-exec1.eps,width=6 cm}
\end{center}

As you can read on the Xlurette output window, a fake environment has
been generated into the {\tt onlyroll\_env.lut} file
(cf~Appendix~\ref{lutin-app}).  Is is a \lutin~\cite{roux02}
description of the environment of {\tt onlyroll.lus}, which inputs
are the {\tt onlyroll} program outputs, and vice-versa: boolean
variables are randomly drawn, and numeric values are drawn between 0
and 1.

Of course, most of the time, this automatically generated environment
will not be particularly pertinent, but it can serve as a basis for
writing your own description of the environment of the program you
want to test.

Now, if you click on the chronogram button 
\epsfig{figure=chrono.eps,width=1 cm}, 
a chronogram of the data that have been generated at the previous run
is displayed.

\begin{center}  
\epsfig{figure=sim2chro-onlyroll.eps,width=6 cm}
\end{center}

If you wish to automate the test perusal, you can also feed the
oracle text input window with the name of a lustre program which
inputs are the onlyroll program inputs and outputs, and which outputs
is a boolean that ought to say whether or not the test succeeded. \\


If you click on the parameter thumbnail of the Xlurette main window,
you have access to a panel where you can set various parameters. The
meaning of each  parameters is described by tool-tips that
ought to be enough to understand what they are all about.

\begin{center}
\epsfig{figure=xlurette-parameters.eps,width=6 cm}
\end{center}




\begin{figure}[h]
%\hline
\begin{alltt}
model onlyroll_env (x : real)
returns (
    xa1 : real; xb1 : real; disc1 : bool; choff1 : bool;
    xa2 : real; xb2 : real; disc2 : bool; choff2 : bool;
    xa3 : real; xb3 : real; disc3 : bool; choff3 : bool;
    xa4 : real; xb4 : real; disc4 : bool; choff4 : bool;
    ongroundreset : bool; inairreset : bool )
let
    fake_constraints = true 
        and (0. < xa1) and (xa1 < 1.)
        and (0. < xb1) and (xb1 < 1.)
        and (0. < xa2) and (xa2 < 1.)
        and (0. < xb2) and (xb2 < 1.)
        and (0. < xa3) and (xa3 < 1.)
        and (0. < xb3) and (xb3 < 1.)
        and (0. < xa4) and (xa4 < 1.)
        and (0. < xb4) and (xb4 < 1.)
        ;
   onlyroll_env = { loop fake_constraints pool };
tel    
\end{alltt}
%\hline
\caption{The automatically generated environment for {\tt onlyroll.lus} 
(it is a simplistic \lutin\ version of the environment given in Figure~\ref{gyro-luc}) 
\label{lutin-app} \label{gyro-lut}}
\end{figure}

% (*---------------------------------------------------------------------*)
\newpage
\section{Tools user interface}
\label{tools}

\subsection{\xlurette}
\label{xlurette}
\xlurette\ is a Graphical interface over lurettetop, which lets one
automatically test reactive programs written in lustre.  Its usage is
the following:

\begin{alltt}
     usage: xlurette [<options>] <env+>
\end{alltt}


\noindent
where {\tt <env>} is a lucky (.luc) file, and where command line {\tt
  <options>} are:

\begin{alltt}
  --sut <string>        File name of the system under test.
  -sut  <string>

  --oracle <string>     File name of the oracle.
  -oracle  <string>

  --test-length <int>   Number of steps to be done
  -l <int>              (default=50).

  --thick-form <int>    Number of formula to be drawn at each step
  -tf <int>             (default=1).

  --thick-draw <int>    Number of draw to be done in each formula 
  -td <int>             at each step (default=1).

  --draw-inside         Draw inside the polyhedron of solutions.
 
  --draw-edges          Draw on the edges of the polyhedron of solutions.
 
  --draw-verteces       Draw among the verteces of the polyhedron of solutions.
 
  --output <string>     Set the output file name (default is "lurette.rif").
  -o <string>

  --help                Display this list of options.
  -help 
  -h 
\end{alltt}

%---------------------------------------------------------------------%
\subsection{\lurettetop}
\label{lurettetop}
\lurettetop\ is a small top level loop that let one use lurette.  Its
usage is the following:

\begin{alltt}
       usage: lurettetop [<options>] <env>+
\end{alltt}

\noindent
where {\tt <env>} is a lucky (.luc) file, and where command line {\tt
  <options>} are:


\begin{alltt}
  --sut <string>        File name of the system under test.
  -sut  <string>

  --main-sut-node <string> Main node name of the system under test.
  -msn  <string>

  --oracle <string>     File name of the oracle.
  -oracle  <string>

  --main-oracle-node <string>   Main node name of the oracle.
  -man  <string>

  --test-length <int>   Number of steps to be done
  -l <int> 

  --thick-form <int>    Number of formula to be drawn at each step
  -tf <int>

  --thick-draw <int>    Number of draw to be done in each formula 
  -td <int>             at each step.

  --draw-inside         Draw on the edges of the convex hull of solutions.
 
  --draw-edges          Draw on the edges of the convex hull of solutions.
 
  --draw-verteces       Draw among the verteces of the convex hull of solutions.
 
  --seed <int>          Seed the random engine is init with.
  -seed  <int>

  --make-opt <string>   Options to call make with when building 
                        lurette (default="nc").

  --output <string>     Set the output file name (default is "lurette.rif").
  -o <string>

  --go                  Start the testing process directly without prompting.
  -go 

  --step                Run lurette step by step.
  -s 

  --show-step           Set on the show step mode.
  --do-not-show-step            Set off the show step mode.
  --verbose             Set on the verbose mode.
  -v 

  --prompt              Replace the default prompt.

  --prefix              string to append before the call to lurette 
                        (e.g., "/usr/bin/times ").

  --sim2chro            Call sim2chro when lurette resumes.

  --no-sim2chro         Do not call sim2chro when lurette resumes.
  -ns2c 

  --local-var           Display environment local variables in sim2chro.
  --no-local-var        Do not display environment local variables in sim2chro.

  --help                Display this list of options.
  -help 
  -h 
\end{alltt}

Once you have invoked lurettetop from a shell (with or without
options), the lurette prompt is displayed. Then, the {\tt help} command 
shows a synopsis of the available commands.

\begin{alltt}
  <lurette 1> help
The commands are: 

run, r
     to start the testing process. Note that the sut and the environment
     fields (described below) should be set.

quit q, bye  
     to quit the lurette top level

help, h, ?
     display this list of commands

man
     display a small user manual

clean
     run a make clean (you can try it if <<run>> failed)

show
    show of post-script version of the current environment

set\_env  "<env+>"  (env=<file name>)                   
     to set the environment field (.luc files). Automata of
     environments separated by "x" are multiplied.
     The current value of this field is UNSET!

set\_sut  <file name> [<sut file name> <main node name>]            
     to set the sut field. Its current value is UNSET!

set\_oracle  <file name>  [<oracle file name> <main node name>]
     to set the oracle field. Its current value is unset
    
set\_test\_length  <integer>
     to set the test length. Its current value is "10"

set\_formula\_nb  <integer>                      
     to set the number of formula to be drawn at each step. Its current 
     value is "1"

set\_draw\_nb  <integer>
     to set the number of draw to be done in each formula at each step
     Its current value is "1"

set\_draw\_mode <draw\_mode>
    set the draw mode, which can be either be inside, edges, or verteces.
    - inside : draw inside the convex hull of solutions.
    - edges : draw on the edges of the convex hull of solutions.
    - verteces : draw among the verteces of the convex hull of solutions.
    Its current mode is "inside".

set\_seed  <integer>
     to set the seed the random engine is initialised with.
     Its current value is chose randomly

set\_seed\_randomly
     to the system set a seed randomly.
  
set\_step\_by\_step  <boolean>
     to set a flag saying whether or not the test should proceed step
     by step. Its current value is "false"

set\_display\_sim2chro  <boolean>
     to set a flag saying whether or not sim2chro is called when 
       lurette resumes. Its current value is "true"

set\_display\_local\_var  <boolean>
     to set a flag saying whether or not the local var be displayed in  
     sim2cro. Its current value is "true"

set\_verbose  <boolean>
     to set on and off a verbose mode. Its current value is "false"

set\_show\_step  <boolean>
     to set on and off a show step mode. Its current value is "false"

set\_prefix  "<string>"
     to set the string that is appended before the call to lurette.
     This useful, e.g., for timings.
     Its current value is ""

set\_make\_opt  <string>
     to set the options to give to make for building lurette
     Its current value is "nc"

set\_output  <string>
     to set the name of the file the (rif) output of the test is
     put into. Its current value is "lurette.rif"

sim2chro
    call sim2chro
\end{alltt}

\subsection{\lucky}
\label{lucky}
\lucky\ is a command-line lucky file interpreter.  Once invoked, it 
read its input on stdin, and write its output on stdout.
Its usage is the following:


% At least one lucky file is required. If several files are provided,
% then all the automata that shares variable names in outputs (or
% locals) are multiplied (in the sense of Appendix~\ref{product}).

\begin{alltt}
  lucky [options]* <env>+
\end{alltt}
 where {\tt <env>} is a lucky file, and where options are:

\begin{alltt}
   --boot        The automata starts generating values.
   -boot
   -b
     
   --with-seed   Set the value of the seed the random engine is
   -seed         initialised with (0 lets the system draw a seed).
      
   --show-aut    Run lucky showing the lucky automata step.
   -s
            
   --no-show-aut Do not show the luc automata (Default).

   --verbose     Set on a verbose mode.
   -v
\end{alltt}

\subsection{\showluc}

\showluc\ is a tool that produce a graphical post-script display of a
lucky file. It is called whenever the step-by-step mode of
\xlurette/\lurettetop/\lucky\ is used.

\subsection{\genfake}

\genfake\ is a tool take a C header file at the poc format and
generates a lutin file containing a fake lutin description of the
environment of the header file. It is used by \xlurette/\lurettetop\ 
whenever no environment is provided. It can be useful to serve as a
basis to write an environment for a given lustre program from
scratch.


%---------------------------------------------------------------------

\end{document}  


